/********************************************************************
  ROMENetFolder.h, M. Schneebeli PSI

  $Id: ROMENetFolder.h 1739 2007-03-15 07:49:14Z schneebeli_m $

********************************************************************/

#ifndef ROMENetFolder_H
#define ROMENetFolder_H

#include "TNetFolder.h"

class ROMENetFolder : public TNetFolder
{
public:
   ROMENetFolder():TNetFolder() {}
   ROMENetFolder( const char *name, const char *title, TSocket *socket,Bool_t reconnect=true):TNetFolder(name,title,socket,reconnect) {}
   virtual ~ROMENetFolder(){}

   Long64_t GetCurrentRunNumber();
   Long64_t GetCurrentEventNumber();
   Bool_t RegisterObject(const char* name);
   Bool_t UnRegisterObject(const char* name);
   Bool_t RequestNewEvent(Long64_t oldRunNumber,Long64_t oldEventNumber);
   Bool_t RequestEvent();
   Bool_t IsProgramTerminated();

   ClassDef(ROMENetFolder, 0) // Customized TNetFolder for ROME
};

#endif   // ROMENetFolder_H
